REM Sub Findcode v1.2a PD 2004.
DIM Routines(1024) AS STRING
COLOR 15, 0
PRINT "Subroutine finder v1.0a:"
CommandLine$ = COMMAND$
IF LEN(CommandLine$) THEN
   Var = INSTR(CommandLine$, "/X")
   IF Var THEN
      CommandLine$ = LEFT$(CommandLine$, Var - 1) + MID$(CommandLine$, Var + 2)
      OutputFile = -1
   END IF
END IF
IF CommandLine$ = "/?" OR CommandLine$ = "-?" THEN
   COLOR 14, 0
   PRINT "Finds subroutines in Basic source files;"
   PRINT "Specify subroutine to find on command line."
   PRINT "Do not prefix 'Sub'."
   COLOR 7, 0
   PRINT "Exiting to system:"
   END
END IF
IF CommandLine$ = "" THEN
   COLOR 15, 0
   PRINT "Enter subroutine name";
   INPUT CommandLine$
END IF
Search$ = "Sub " + CommandLine$
COLOR 15, 0
PRINT "Finding: "; CHR$(34);
COLOR 14, 0
PRINT Search$;
COLOR 15, 0
PRINT CHR$(34); " ";
VarF! = TIMER
Routine1 = 0
CommandLine$ = LTRIM$(CommandLine$)
CommandLine$ = RTRIM$(CommandLine$)
CommandLine$ = "sub " + CommandLine$
CommandLine$ = LCASE$(CommandLine$)
Length = LEN(CommandLine$)
FileSpec$ = "*.bas"
Filename$ = DIR$(FileSpec$)
WHILE LEN(Filename$)
   CLOSE #1
   OPEN Filename$ FOR INPUT AS #1
   GOSUB Dot.Display
   DO WHILE NOT EOF(1)
      LINE INPUT #1, InputLine$
      IF INSTR(InputLine$, "(") THEN
         InputLine$ = RTRIM$(LEFT$(InputLine$, INSTR(InputLine$, "(") - 1))
      END IF
      IF LCASE$(LTRIM$(InputLine$)) = CommandLine$ THEN
         Routine1 = Routine1 + 1
         Routines(Routine1) = Filename$
         EXIT DO
      END IF
   LOOP
   Filename$ = DIR$
WEND
PRINT
IF Routine1 > 1 THEN
   FOR Sort1 = 1 TO Routine1
      FOR Sort2 = Sort1 + 1 TO Routine1
         IF Routines(Sort1) > Routines(Sort2) THEN
            SWAP Routines(Sort1), Routines(Sort2)
         END IF
      NEXT
   NEXT
END IF
COLOR 15, 0
SELECT CASE Routine1
CASE 0
   PRINT "No Subroutines found."
CASE 1
   PRINT "Total of 1 subroutine found."
CASE ELSE
   PRINT "Total of"; Routine1; "subroutines found."
END SELECT
Page = 1
COLOR 14, 0
IF Routine1 > 0 THEN
   IF OutputFile THEN
      CLOSE
      OPEN "finddata.dat" FOR OUTPUT AS #1
   END IF
   FOR Var = 1 TO Routine1
      Filename$ = Routines(Var)
      Filename$ = Filename$ + SPACE$(15 - LEN(Filename$))
      IF OutputFile THEN
         PRINT #1, Filename$;
      ELSE
         PRINT Filename$;
      END IF
      Line1 = Line1 + 1
      IF Line1 = 5 THEN
         IF OutputFile THEN
            PRINT #1, ""
         ELSE
            PRINT
            Page = Page + 1
            IF Page = 23 THEN
               Page = 0
               COLOR 15, 0
               PRINT "More:";
               WHILE INKEY$ = ""
               WEND
               PRINT
               COLOR 14, 0
            END IF
         END IF
         Line1 = 0
      END IF
   NEXT
END IF
IF OutputFile THEN
   PRINT #1, ""
ELSE
   PRINT
END IF
IF OutputFile THEN
   PRINT "Data written to Finddata.dat"
END IF
COLOR 7, 0
PRINT "Exiting to system:"
END

Dot.Display:
 VarG! = TIMER - VarE!
 IF VarG! < 0! THEN
    VarG! = Elapsed.Time! + 86400!
 END IF
 IF VarG! >= 1! THEN
    VarE! = TIMER
    IF VarD = 0 THEN
       VarC = VarC + 1
       PRINT ".";
       IF VarC = 5 THEN
          VarD = -1
          VarC = 0
       END IF
    ELSE
       VarC = VarC + 1
       LOCATE CSRLIN, POS(0) - 1, 0
       PRINT " ";
       LOCATE CSRLIN, POS(0) - 1, 1
       IF VarC = 5 THEN
          VarD = 0
          VarC = 0
       END IF
    END IF
 END IF
 RETURN

